# aws-cognito-user-pool

Terraform module to build and manage a Cognito user pool.

## Usage

### With custom domain for user pool

```hcl-terraform
module "cognito_user_pool" {
  source = "git::https://gitlab.com/open-source-devex/terraform-modules/aws/cognito-user-pool.git?ref=v3.0.0"

  project     = "my-project"
  environment = "my-environment"

  configure_custom_domain = true

  user_pool_custom_domain_name            = "example.com"
  user_pool_custom_domain_certificate_arn = "${var.certificate_arn}"
  user_pool_custom_domain_route53_zone_id = "${var.route53_zone_id}"

  default_user_pool_client_callback_urls = ["https://wwww.exmaple.com/login"]
  default_user_pool_client_logout_urls   = ["https://wwww.example.com/logout"]
}
```

### Without custom domain for user pool

```hcl-terraform
module "cognito_user_pool" {
  source = "git::https://gitlab.com/open-source-devex/terraform-modules/aws/cognito-user-pool.git?ref=v3.0.0"

  project     = "my-project"
  environment = "my-environment"

  configure_custom_domain = false

  default_user_pool_client_callback_urls = ["https://wwww.exmaple.com/login"]
  default_user_pool_client_logout_urls   = ["https://wwww.example.com/logout"]
}
```

## Terraform docs

<!-- BEGIN_TF_DOCS -->
## Requirements

No requirements.

## Providers

| Name | Version |
|------|---------|
| <a name="provider_aws"></a> [aws](#provider\_aws) | 3.56.0 |

## Modules

No modules.

## Resources

| Name | Type |
|------|------|
| [aws_cognito_identity_provider.user_pool_idp](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_identity_provider) | resource |
| [aws_cognito_user_group.groups](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_user_group) | resource |
| [aws_cognito_user_pool.default](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_user_pool) | resource |
| [aws_cognito_user_pool_client.ignore_changes_to_callback_urls](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_user_pool_client) | resource |
| [aws_cognito_user_pool_client.strict](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_user_pool_client) | resource |
| [aws_cognito_user_pool_domain.custom_domain](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_user_pool_domain) | resource |
| [aws_cognito_user_pool_domain.default_domain](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/cognito_user_pool_domain) | resource |
| [aws_route53_record.cognito_domain_alias_target_subdomain](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/route53_record) | resource |
| [aws_route53_record.cognito_domain_alias_target_subdomain_ipv6](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/route53_record) | resource |
| [aws_region.current](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/data-sources/region) | data source |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| <a name="input_cloudfront_distribution_dnz_zone_id"></a> [cloudfront\_distribution\_dnz\_zone\_id](#input\_cloudfront\_distribution\_dnz\_zone\_id) | The id of the Route53 zone used by AWS for CloudFront. This is typically constant, unless things change on AWS' side. | `string` | `"Z2FDTNDATAQYW2"` | no |
| <a name="input_configure_custom_domain"></a> [configure\_custom\_domain](#input\_configure\_custom\_domain) | Whether to configure a custom domain name, or use the default generated by the module. | `bool` | `false` | no |
| <a name="input_environment"></a> [environment](#input\_environment) | The environment name. Used for naming resources and domains. | `string` | n/a | yes |
| <a name="input_project"></a> [project](#input\_project) | The project name. Used for naming resources and domains. | `string` | n/a | yes |
| <a name="input_remember_device"></a> [remember\_device](#input\_remember\_device) | Should the user pool store information about user devices. | `bool` | `false` | no |
| <a name="input_user_pool_alias_attributes"></a> [user\_pool\_alias\_attributes](#input\_user\_pool\_alias\_attributes) | The user pool attributes used for identifying users. | `list(string)` | <pre>[<br>  "email"<br>]</pre> | no |
| <a name="input_user_pool_auto_verified_attributes"></a> [user\_pool\_auto\_verified\_attributes](#input\_user\_pool\_auto\_verified\_attributes) | The user pool attributes that are auto verified. | `list(string)` | <pre>[<br>  "email"<br>]</pre> | no |
| <a name="input_user_pool_clients"></a> [user\_pool\_clients](#input\_user\_pool\_clients) | A list of objects describing the clients | <pre>map(object({<br>    name                            = string<br>    generate_secret                 = bool<br>    allow_oauth_flows               = bool<br>    callback_urls                   = list(string)<br>    callback_domains                = list(string)<br>    logout_urls                     = list(string)<br>    allowed_oauth_flows             = list(string)<br>    allowed_oauth_scopes            = list(string)<br>    explicit_auth_flows             = list(string)<br>    identity_providers              = list(string)<br>    write_attributes                = list(string)<br>    ignore_changes_to_callback_urls = optional(bool)<br>  }))</pre> | <pre>{<br>  "client1": {<br>    "allow_oauth_flows": true,<br>    "allowed_oauth_flows": [<br>      "code"<br>    ],<br>    "allowed_oauth_scopes": [<br>      "openid",<br>      "email"<br>    ],<br>    "callback_domains": [],<br>    "callback_urls": [],<br>    "explicit_auth_flows": [<br>      "ADMIN_NO_SRP_AUTH"<br>    ],<br>    "generate_secret": true,<br>    "identity_providers": [<br>      "COGNITO"<br>    ],<br>    "logout_urls": [],<br>    "name": "default-client",<br>    "write_attributes": [<br>      "name",<br>      "email"<br>    ]<br>  }<br>}</pre> | no |
| <a name="input_user_pool_custom_attributes"></a> [user\_pool\_custom\_attributes](#input\_user\_pool\_custom\_attributes) | Custom attributes to be configured on the user pool. | <pre>map(object({<br>    name                     = string<br>    attribute_data_type      = string<br>    developer_only_attribute = optional(bool)<br>    mutable                  = optional(bool)<br>    number_attribute_constraints = optional(object({<br>      max_value = number<br>      min_value = number<br>    }))<br>    string_attribute_constraints = optional(object({<br>      max_length = number<br>      min_length = number<br>    }))<br>  }))</pre> | `{}` | no |
| <a name="input_user_pool_custom_domain_certificate_arn"></a> [user\_pool\_custom\_domain\_certificate\_arn](#input\_user\_pool\_custom\_domain\_certificate\_arn) | The ARN of the certificate for the custom domain. | `string` | `""` | no |
| <a name="input_user_pool_custom_domain_name"></a> [user\_pool\_custom\_domain\_name](#input\_user\_pool\_custom\_domain\_name) | The full (custom) domain name for the user pool. | `string` | `""` | no |
| <a name="input_user_pool_custom_domain_route53_zone_id"></a> [user\_pool\_custom\_domain\_route53\_zone\_id](#input\_user\_pool\_custom\_domain\_route53\_zone\_id) | The id of the Route53 zone for the custom domain. | `string` | `""` | no |
| <a name="input_user_pool_default_domain_name"></a> [user\_pool\_default\_domain\_name](#input\_user\_pool\_default\_domain\_name) | The prefix for the AWS generated domain name for the user pool. | `string` | `""` | no |
| <a name="input_user_pool_groups"></a> [user\_pool\_groups](#input\_user\_pool\_groups) | Groups defined in the user pool. | `map(string)` | `{}` | no |
| <a name="input_user_pool_identity_provider_attribute_mapping"></a> [user\_pool\_identity\_provider\_attribute\_mapping](#input\_user\_pool\_identity\_provider\_attribute\_mapping) | A mapping of idp attributes to user pool attributes. | `map(string)` | `{}` | no |
| <a name="input_user_pool_identity_provider_details"></a> [user\_pool\_identity\_provider\_details](#input\_user\_pool\_identity\_provider\_details) | The configuration for the idp. Should include 'MetadataFile', 'SSORedirectBindingURI', and all other required parameters. | `map(string)` | `{}` | no |
| <a name="input_user_pool_identity_provider_name"></a> [user\_pool\_identity\_provider\_name](#input\_user\_pool\_identity\_provider\_name) | The name for an identity provider. If set this will trigger the creation of the idp. | `string` | `""` | no |
| <a name="input_user_pool_identity_provider_type"></a> [user\_pool\_identity\_provider\_type](#input\_user\_pool\_identity\_provider\_type) | The type of the idp. | `string` | `""` | no |
| <a name="input_user_pool_name"></a> [user\_pool\_name](#input\_user\_pool\_name) | Name for the Cognito user pool. When this input is not supplied, the value defaults to `"${var.project}-${var.environment}"`. | `string` | `""` | no |
| <a name="input_user_pool_password_min_length"></a> [user\_pool\_password\_min\_length](#input\_user\_pool\_password\_min\_length) | Minimum password length. | `number` | `60` | no |
| <a name="input_user_pool_password_req_lowercase"></a> [user\_pool\_password\_req\_lowercase](#input\_user\_pool\_password\_req\_lowercase) | Passwords require lowercase characters. | `bool` | `true` | no |
| <a name="input_user_pool_password_req_numbers"></a> [user\_pool\_password\_req\_numbers](#input\_user\_pool\_password\_req\_numbers) | Passwords require number characters. | `bool` | `true` | no |
| <a name="input_user_pool_password_req_symbols"></a> [user\_pool\_password\_req\_symbols](#input\_user\_pool\_password\_req\_symbols) | Passwords require symbol characters. | `bool` | `true` | no |
| <a name="input_user_pool_password_req_uppercase"></a> [user\_pool\_password\_req\_uppercase](#input\_user\_pool\_password\_req\_uppercase) | Passwords require uppercase characters. | `bool` | `true` | no |
| <a name="input_user_pool_temporary_password_validity_days"></a> [user\_pool\_temporary\_password\_validity\_days](#input\_user\_pool\_temporary\_password\_validity\_days) | Days until a temporary password becomes invalid. | `number` | `7` | no |

## Outputs

| Name | Description |
|------|-------------|
| <a name="output_user_pool_arn"></a> [user\_pool\_arn](#output\_user\_pool\_arn) | n/a |
| <a name="output_user_pool_client_secrets"></a> [user\_pool\_client\_secrets](#output\_user\_pool\_client\_secrets) | n/a |
| <a name="output_user_pool_clients"></a> [user\_pool\_clients](#output\_user\_pool\_clients) | n/a |
| <a name="output_user_pool_domain_name"></a> [user\_pool\_domain\_name](#output\_user\_pool\_domain\_name) | n/a |
| <a name="output_user_pool_id"></a> [user\_pool\_id](#output\_user\_pool\_id) | n/a |
<!-- END_TF_DOCS -->
